DROP VIEW DSS_PlazosPrepagos
GO

CREATE VIEW DSS_PlazosPrepagos
AS

SELECT 'RE ' + LTRIM(RTRIM(STR(re.nro_reserva))) nro_reserva, ta.contrato, re.nombre,
       re.fecha_ent, re.fecha_sal, me.desc_merc,
       ISNULL(dbo.fRese_Importe_TOTAL(re.nro_reserva), 0) + ISNULL(dbo.Rese_Importe_prepagado(re.nro_reserva), 0) total,
       (SELECT MAX(p2.fecha_plazo) FROM HOTEREGA p2 WHERE p2.id_rese = re.id_rese) ultimo_plazo,
       pl.id_rega, pl.fecha_plazo, pl.importe, pl.pagado_mon_cont, pl.diferencia,
       'DG ' + LTRIM(RTRIM(STR(dg.nro_dega))) prepago, dg.importe importe_dega, td.cod_endg,
       (SELECT SUM(pl2.importe) FROM WFDK_ReservaPlazos pl2 WHERE pl2.id_rese = re.id_rese) ImportePlazo,
       (SELECT SUM(pl2.pagado_mon_cont) FROM WFDK_ReservaPlazos pl2 WHERE pl2.id_rese = re.id_rese) Pagado,
       (SELECT SUM(pl2.diferencia) FROM WFDK_ReservaPlazos pl2 WHERE pl2.id_rese = re.id_rese) Restante
FROM       HOTERESE re
INNER JOIN HOTECONT ta ON re.id_cont = ta.id_cont
INNER JOIN HOTEMERC me ON ta.id_merc = me.id_merc
INNER JOIN WFDK_ReservaPlazos pl ON re.id_rese = pl.id_rese
LEFT  JOIN HOTEREGL rd ON pl.id_rega = rd.id_rega
LEFT  JOIN HOTEDEGA dg ON rd.id_dega = dg.id_dega
LEFT  JOIN HOTEENDG td ON dg.id_endg = td.id_endg
UNION ALL
SELECT 'RE ' + LTRIM(RTRIM(STR(re.nro_reserva))) nro_reserva, ta.contrato, re.nombre,
       re.fecha_ent, re.fecha_sal, me.desc_merc,
       ISNULL(dbo.fRese_Importe_TOTAL_Hist(re.nro_reserva), 0) + ISNULL(dbo.Rese_Importe_prepagado_hist(re.nro_reserva), 0) total,
       (SELECT MAX(p2.fecha_plazo) FROM HOTEHREGA p2 WHERE p2.id_rese = re.id_rese) ultimo_plazo,
       pl.id_rega, pl.fecha_plazo, pl.importe, pl.pagado_mon_cont, pl.diferencia,
       'DG ' + LTRIM(RTRIM(STR(dg.nro_dega))) prepago, dg.importe importe_dega, td.cod_endg,
       (SELECT SUM(pl2.importe) FROM WFDK_ReservaPlazosHist pl2 WHERE pl2.id_rese = re.id_rese) ImportePlazo,
       (SELECT SUM(pl2.pagado_mon_cont) FROM WFDK_ReservaPlazosHist pl2 WHERE pl2.id_rese = re.id_rese) Pagado,
       (SELECT SUM(pl2.diferencia) FROM WFDK_ReservaPlazosHist pl2 WHERE pl2.id_rese = re.id_rese) Restante
FROM       HOTEHRES  re
INNER JOIN HOTECONT  ta ON re.id_cont = ta.id_cont
INNER JOIN HOTEMERC  me ON ta.id_merc = me.id_merc
INNER JOIN WFDK_ReservaPlazosHist pl ON re.id_rese = pl.id_rese
LEFT  JOIN HOTEHREGL rd ON pl.id_rega = rd.id_rega
LEFT  JOIN HOTEHDEG  dg ON rd.id_dega = dg.id_dega
LEFT  JOIN HOTEENDG  td ON dg.id_endg = td.id_endg
UNION ALL
SELECT 'RL ' + LTRIM(RTRIM(STR(ro.nro_rooming))) nro_reserva, ta.contrato, 
       (SELECT TOP 1 hu.nombre
        FROM       HOTEROON hu
        INNER JOIN HOTEROOL d2 ON hu.id_rool = d2.id_rool
        WHERE d2.id_room = ro.id_room) nombre,
       (SELECT MIN(d3.fecha_ent) FROM HOTEROOL d3 WHERE d3.id_room = ro.id_room) fecha_ent, 
       (SELECT MAX(d3.fecha_sal) FROM HOTEROOL d3 WHERE d3.id_room = ro.id_room) fecha_sal, me.desc_merc,
       ISNULL(dbo.FRoom_Importe_TOTAL(ro.nro_rooming), 0) + ISNULL(dbo.Room_Importe_prepagado(ro.nro_rooming), 0) total,
       (SELECT MAX(p2.fecha_plazo) FROM HOTEROGA p2 WHERE p2.id_room = ro.id_room) ultimo_plazo,
       pl.id_roga, pl.fecha_plazo, pl.importe, pl.pagado_mon_cont, pl.diferencia,
       'DG ' + LTRIM(RTRIM(STR(dg.nro_dega))) prepago, dg.importe importe_dega, td.cod_endg,
       (SELECT SUM(pl2.importe) FROM WFDK_RoomingPlazos pl2 WHERE pl2.id_room = ro.id_room) ImportePlazo,
       (SELECT SUM(pl2.pagado_mon_cont) FROM WFDK_RoomingPlazos pl2 WHERE pl2.id_room = ro.id_room) Pagado,
       (SELECT SUM(pl2.diferencia) FROM WFDK_RoomingPlazos pl2 WHERE pl2.id_room = ro.id_room) Restante
FROM       HOTEROOM ro
INNER JOIN HOTECONT ta ON ro.id_cont = ta.id_cont
INNER JOIN HOTEMERC me ON ta.id_merc = me.id_merc
INNER JOIN WFDK_RoomingPlazos pl ON ro.id_room = pl.id_room
LEFT  JOIN HOTEROGL rd ON pl.id_roga = rd.id_roga
LEFT  JOIN HOTEDEGA dg ON rd.id_dega = dg.id_dega
LEFT  JOIN HOTEENDG td ON dg.id_endg = td.id_endg
UNION ALL
SELECT 'RL ' + LTRIM(RTRIM(STR(ro.nro_rooming))) nro_reserva, ta.contrato, 
       (SELECT TOP 1 hu.nombre
        FROM       HOTEHRON hu
        INNER JOIN HOTEHROL d2 ON hu.id_rool = d2.id_rool
        WHERE d2.id_room = ro.id_room) nombre,
       (SELECT MIN(d3.fecha_ent) FROM HOTEHROL d3 WHERE d3.id_room = ro.id_room) fecha_ent, 
       (SELECT MAX(d3.fecha_sal) FROM HOTEHROL d3 WHERE d3.id_room = ro.id_room) fecha_sal, me.desc_merc,
       ISNULL(dbo.froom_Importe_TOTAL_Hist(ro.nro_rooming), 0) + ISNULL(dbo.Room_Importe_prepagado_hist(ro.nro_rooming), 0) total,
       (SELECT MAX(p2.fecha_plazo) FROM HOTEHROGA p2 WHERE p2.id_room = ro.id_room) ultimo_plazo,
       pl.id_roga, pl.fecha_plazo, pl.importe, pl.pagado_mon_cont, pl.diferencia,
       'DG ' + LTRIM(RTRIM(STR(dg.nro_dega))) prepago, dg.importe importe_dega, td.cod_endg,
       (SELECT SUM(pl2.importe) FROM WFDK_RoomingPlazosHist pl2 WHERE pl2.id_room = ro.id_room) ImportePlazo,
       (SELECT SUM(pl2.pagado_mon_cont) FROM WFDK_RoomingPlazosHist pl2 WHERE pl2.id_room = ro.id_room) Pagado,
       (SELECT SUM(pl2.diferencia) FROM WFDK_RoomingPlazosHist pl2 WHERE pl2.id_room = ro.id_room) Restante
FROM       HOTEHROM  ro
INNER JOIN HOTECONT  ta ON ro.id_cont = ta.id_cont
INNER JOIN HOTEMERC  me ON ta.id_merc = me.id_merc
INNER JOIN WFDK_RoomingPlazosHist pl ON ro.id_room = pl.id_room
LEFT  JOIN HOTEHROGL rd ON pl.id_roga = rd.id_roga
LEFT  JOIN HOTEHDEG  dg ON rd.id_dega = dg.id_dega
LEFT  JOIN HOTEENDG  td ON dg.id_endg = td.id_endg