DROP PROCEDURE DSS_PlazosPrepagos_GetInfo
GO

CREATE PROCEDURE DSS_PlazosPrepagos_GetInfo
    @Modo INT,
    @FecIni DATE,
    @FecFin DATE
AS
BEGIN

    SELECT *
    FROM   DSS_PlazosPrepagos
    WHERE  CAST(CASE @Modo 
                     WHEN 0 THEN fecha_plazo
                     WHEN 1 THEN fecha_ent
                     WHEN 2 THEN fecha_sal
                     ELSE ultimo_plazo
                     END AS DATE) BETWEEN @FecIni AND @FecFin
                     
    SELECT MAX(total) Total, MAX(ImportePlazo) ImportePlazo, MAX(Pagado) Pagado, MAX(Restante) Restante
    INTO   #TotalesPP
    FROM   DSS_PlazosPrepagos
    WHERE  CAST(CASE @Modo 
                     WHEN 0 THEN fecha_plazo
                     WHEN 1 THEN fecha_ent
                     WHEN 2 THEN fecha_sal
                     ELSE ultimo_plazo
                     END AS DATE) BETWEEN @FecIni AND @FecFin
    GROUP BY nro_reserva
                     
    SELECT SUM(total) Total, SUM(ImportePlazo) ImportePlazo, SUM(Pagado) Pagado, SUM(Restante) Restante
    FROM   #TotalesPP

    RETURN
    
END