DROP PROCEDURE WFDK_HISTClientes_GetInfo
GO

CREATE PROCEDURE WFDK_HISTClientes_GetInfo
	@Modo INT,
	@Fil_nombre BIT,
	@vFil_nombre VARCHAR(255),
	@Fil_id_carp BIT,
	@vFil_id_carp INT,
	@Fil_pasaporte BIT,
	@vFil_pasaporte VARCHAR(255),
	@Fil_id_naci BIT,
	@vFil_id_naci INT,
	@Fil_ckin_anulado BIT,
	@Fil_fecha_ent BIT,
	@vFil_fecha_ent DATE,
	@vFil_fecha_ent2 DATE,
	@Fil_fecha_sal BIT,
	@vFil_fecha_sal DATE,
	@vFil_fecha_sal2 DATE,
	@Fil_salidas_hotelera BIT,
	@Fil_adulto BIT,
	@vFil_adulto BIT,
	@Fil_genero BIT,
	@vFil_genero BIT
AS
BEGIN

	DECLARE @Fil VARCHAR(1000) = '' 

	Select Nombre = Ltrim(Upper(Nombre)),
	       Habitacion, hotehcli.fecha_ent, hotehcli.fecha_sal,
	       Contrato, hotehcli.dni_cif, nacionalidad desc_nac, hotehcli.id_facn,
	       hotehhab.id_face, Len(RTrim(Habitacion)) as Longi, 
	       HoteCard.e_mail, hotecard.clave_cardex,
	       hotehcli.id_cardex, HOTEHCLI.id_naci,
	       HOTEHCLI.cin_anulado, HOTEHCLI.sexo, HOTEHCLI.adulto
	INTO #HISTClientes
	From Hotehhab 
	inner join hotehcli on hotehhab.id_face = hotehcli.id_face
	inner join hotenaci on hotehcli.id_naci = hotenaci.id_naci
	inner join hotehabi on hotehhab.id_habi = hotehabi.id_habi
	left join  Hotecard on HoteCard.id_Cardex = HoteHcli.id_cardex
	inner join hotecont on hotehhab.id_cont = hotecont.id_cont 
	
	IF @Fil_nombre = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENName: ' + LTRIM(RTRIM(@vFil_nombre))
	
	    DELETE #HISTClientes WHERE LTRIM(RTRIM(LOWER(nombre))) NOT LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_nombre))) + '%' 
	END
	IF @Fil_id_carp = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKPerfilCliente: ' + ISNULL((SELECT LTRIM(RTRIM(clave_cardex)) FROM HOTECARD WHERE id_cardex = @vFil_id_carp), '')
	
	    DELETE #HISTClientes WHERE ISNULL(id_cardex, 0) <> @vFil_id_carp  
	END
	IF @Fil_pasaporte = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKPasaporte: ' + LTRIM(RTRIM(@vFil_pasaporte))
	
	    DELETE #HISTClientes WHERE dni_cif IS NULL OR LTRIM(RTRIM(LOWER(dni_cif))) NOT LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_pasaporte))) + '%' 
	END
	IF @Fil_id_naci = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKSEXNacionalidad: ' + ISNULL((SELECT nacionalidad FROM HOTENACI WHERE id_naci = @vFil_id_naci), '')
	
	    DELETE #HISTClientes WHERE ISNULL(id_naci, 0) <> @vFil_id_naci  
	END
	IF @Fil_ckin_anulado = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKCLHClientesCKINAnul' 
	
	    DELETE #HISTClientes WHERE cin_anulado = 0
	END
	ELSE
	BEGIN
	   DELETE #HISTClientes WHERE cin_anulado = 1
	END
	IF @Fil_fecha_ent = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKEntrada: ' + CAST(@vFil_fecha_ent AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_ent2 AS VARCHAR)
	
	    DELETE #HISTClientes WHERE CAST(fecha_ent AS DATE) NOT BETWEEN @vFil_fecha_ent AND @vFil_fecha_ent2
	END
	IF @Fil_fecha_sal = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENSalida: ' + CAST(@vFil_fecha_sal AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_sal2 AS VARCHAR)
	
	    DELETE #HISTClientes WHERE CAST(fecha_sal AS DATE) NOT BETWEEN @vFil_fecha_sal AND @vFil_fecha_sal2
	END
	IF @Fil_salidas_hotelera = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKHHSalidasDiaActual' 
	
	    DECLARE @fecha_hotelera DATE = (SELECT TOP 1 fecha_hotelera FROM HOTETABL)
	    DELETE #HISTClientes WHERE DateDiff(day, @fecha_hotelera, fecha_sal) <> 0 OR id_face IN (SELECT id_face FROM hoteface) 
	END
	IF @Fil_adulto = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKAdulto: ' + CASE @vFil_adulto WHEN 1 THEN 'LblGENYes' ELSE 'LblGENNo' END
	
	    DELETE #HISTClientes WHERE adulto <> @vFil_adulto  
	END
	IF @Fil_genero = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENGenero: ' + CASE @vFil_genero WHEN 1 THEN 'LblGENMasculinoAbbr' ELSE 'LblGENFemeninoAbbr' END
	
	    DELETE #HISTClientes WHERE sexo <> @vFil_genero  
	END
	
	IF @Modo = 1
	BEGIN
		
		SELECT TOP 300 id_facn, id_face, Nombre, Habitacion,
		       fecha_ent, fecha_sal, Contrato, dni_cif,
		       desc_nac, 0 eliminado
		FROM   #HISTClientes
		ORDER BY fecha_ent, id_facn
		
	END
	ELSE
	BEGIN
		
		SELECT id_facn, id_face, Nombre, Habitacion,
		       fecha_ent, fecha_sal, Contrato, dni_cif,
		       desc_nac, adulto
		FROM   #HISTClientes
		ORDER BY fecha_ent, id_facn
		
		SELECT @Fil Filtro
		
	END

	RETURN

END